Skip to content

# Module: "renderer-api/k8s-api"

## Index

### Enumerations

- KubeObjectStatusLevel

### Classes

- CRDResourceStore
- CRDStore
- ClusterRole
- ClusterRoleBinding
- ConfigMap
- ConfigMapsStore
- CronJob
- CronJobStore
- CustomResourceDefinition
- DaemonSet
- DaemonSetStore
- Deployment
- DeploymentApi
- DeploymentStore
- Endpoint
- EndpointStore
- EventStore
- HPAStore
- HorizontalPodAutoscaler
- Ingress
- IngressApi
- IngressStore
- Job
- JobStore
- KubeApi
- KubeEvent
- KubeObject
- KubeObjectStore
- LimitRange
- LimitRangesStore
- Namespace
- NamespaceStore
- NetworkPolicy
- NetworkPolicyStore
- Node
- NodesApi
- NodesStore
- PersistentVolume
- PersistentVolumeClaim
- PersistentVolumeClaimsApi
- PersistentVolumesStore
- Pod
- PodDisruptionBudget
- PodDisruptionBudgetsStore
- PodsApi
- PodsStore
- ReplicaSet
- ReplicaSetStore
- ResourceQuota
- ResourceQuotasStore
- Role
- RoleBinding
- RoleBindingsStore
- RolesStore
- Secret
- SecretsStore
- Service
- ServiceAccount
- ServiceAccountsStore
- ServiceStore
- StatefulSet
- StatefulSetStore
- StorageClass
- StorageClassStore
- VolumeClaimStore

### Interfaces

- IKubeApiCluster
- IPodContainer
- IPodContainerStatus
- ISecretRef

### Type aliases

- KubeObjectStatus

### Variables

- apiManager
- clusterRoleApi
- clusterRoleBindingApi
- configMapApi
- crdApi
- cronJobApi
- daemonSetApi
- deploymentApi
- endpointApi
- eventApi
- hpaApi
- ingressApi
- jobApi
- limitRangeApi
- namespacesApi
- networkPolicyApi
- nodesApi
- pdbApi
- persistentVolumeApi
- podsApi
- pvcApi
- replicaSetApi
- resourceQuotaApi
- roleApi
- roleBindingApi
- secretsApi
- serviceAccountsApi
- serviceApi
- statefulSetApi
- storageClassApi

### Functions

- forCluster
- isAllowedResource

## Type aliases

### KubeObjectStatus

Ƭ KubeObjectStatus: object

Defined in src/extensions/renderer-api/kube-object-status.ts:1

#### Type declaration:

- level: KubeObjectStatusLevel

- text: string

- timestamp? : string

## Variables

### `Const` apiManager

• apiManager: ApiManager‹› = new ApiManager()

Defined in src/renderer/api/api-manager.ts:64

### `Const` clusterRoleApi

• clusterRoleApi: KubeApi‹ClusterRole‹›› = new KubeApi({ objectConstructor: ClusterRole, })

Defined in src/renderer/api/endpoints/cluster-role.api.ts:12

### `Const` clusterRoleBindingApi

• clusterRoleBindingApi: KubeApi‹ClusterRoleBinding‹›› = new KubeApi({ objectConstructor: ClusterRoleBinding, })

Defined in src/renderer/api/endpoints/cluster-role-binding.api.ts:10

### `Const` configMapApi

• configMapApi: KubeApi‹ConfigMap‹›› = new KubeApi({ objectConstructor: ConfigMap, })

Defined in src/renderer/api/endpoints/configmap.api.ts:26

### `Const` crdApi

• crdApi: KubeApi‹CustomResourceDefinition‹›› = new KubeApi({ objectConstructor: CustomResourceDefinition, checkPreferredVersion: true, })

Defined in src/renderer/api/endpoints/crd.api.ts:154

### `Const` cronJobApi

• cronJobApi: CronJobApi‹› = new CronJobApi({ objectConstructor: CronJob, })

Defined in src/renderer/api/endpoints/cron-job.api.ts:131

### `Const` daemonSetApi

• daemonSetApi: KubeApi‹DaemonSet‹›› = new KubeApi({ objectConstructor: DaemonSet, })

Defined in src/renderer/api/endpoints/daemon-set.api.ts:74

### `Const` deploymentApi

• deploymentApi: DeploymentApi‹› = new DeploymentApi({ objectConstructor: Deployment, })

Defined in src/renderer/api/endpoints/deployment.api.ts:192

### `Const` endpointApi

• endpointApi: KubeApi‹Endpoint‹›› = new KubeApi({ objectConstructor: Endpoint, })

Defined in src/renderer/api/endpoints/endpoint.api.ts:127

### `Const` eventApi

• eventApi: KubeApi‹KubeEvent‹›› = new KubeApi({ objectConstructor: KubeEvent, })

Defined in src/renderer/api/endpoints/events.api.ts:59

### `Const` hpaApi

• hpaApi: KubeApi‹HorizontalPodAutoscaler‹›› = new KubeApi({ objectConstructor: HorizontalPodAutoscaler, })

Defined in src/renderer/api/endpoints/hpa.api.ts:143

### `Const` ingressApi

• ingressApi: IngressApi‹› = new IngressApi({ objectConstructor: Ingress, // Add fallback for Kubernetes <1.19 checkPreferredVersion: true, fallbackApiBases: ["/apis/extensions/v1beta1/ingresses"], logStuff: true } as any)

Defined in src/renderer/api/endpoints/ingress.api.ts:177

### `Const` jobApi

• jobApi: KubeApi‹Job‹›› = new KubeApi({ objectConstructor: Job, })

Defined in src/renderer/api/endpoints/job.api.ts:110

### `Const` limitRangeApi

• limitRangeApi: KubeApi‹LimitRange‹›› = new KubeApi({ objectConstructor: LimitRange, })

Defined in src/renderer/api/endpoints/limit-range.api.ts:55

### `Const` namespacesApi

• namespacesApi: KubeApi‹Namespace‹›› = new KubeApi({ objectConstructor: Namespace, })

Defined in src/renderer/api/endpoints/namespaces.api.ts:25

### `Const` networkPolicyApi

• networkPolicyApi: KubeApi‹NetworkPolicy‹›› = new KubeApi({ objectConstructor: NetworkPolicy, })

Defined in src/renderer/api/endpoints/network-policy.api.ts:71

### `Const` nodesApi

• nodesApi: NodesApi‹› = new NodesApi({ objectConstructor: Node, })

Defined in src/renderer/api/endpoints/nodes.api.ts:169

### `Const` pdbApi

• pdbApi: KubeApi‹PodDisruptionBudget‹›› = new KubeApi({ objectConstructor: PodDisruptionBudget, })

Defined in src/renderer/api/endpoints/poddisruptionbudget.api.ts:47

### `Const` persistentVolumeApi

• persistentVolumeApi: KubeApi‹PersistentVolume‹›› = new KubeApi({ objectConstructor: PersistentVolume, })

Defined in src/renderer/api/endpoints/persistent-volume.api.ts:79

### `Const` podsApi

• podsApi: PodsApi‹› = new PodsApi({ objectConstructor: Pod, })

Defined in src/renderer/api/endpoints/pods.api.ts:469

### `Const` pvcApi

• pvcApi: PersistentVolumeClaimsApi‹› = new PersistentVolumeClaimsApi({ objectConstructor: PersistentVolumeClaim, })

Defined in src/renderer/api/endpoints/persistent-volume-claims.api.ts:90

### `Const` replicaSetApi

• replicaSetApi: ReplicaSetApi‹› = new ReplicaSetApi({ objectConstructor: ReplicaSet, })

Defined in src/renderer/api/endpoints/replica-set.api.ts:83

### `Const` resourceQuotaApi

• resourceQuotaApi: KubeApi‹ResourceQuota‹›› = new KubeApi({ objectConstructor: ResourceQuota, })

Defined in src/renderer/api/endpoints/resource-quota.api.ts:66

### `Const` roleApi

• roleApi: KubeApi‹Role‹›› = new KubeApi({ objectConstructor: Role, })

Defined in src/renderer/api/endpoints/role.api.ts:21

### `Const` roleBindingApi

• roleBindingApi: KubeApi‹RoleBinding‹›› = new KubeApi({ objectConstructor: RoleBinding, })

Defined in src/renderer/api/endpoints/role-binding.api.ts:34

### `Const` secretsApi

• secretsApi: KubeApi‹Secret‹›› = new KubeApi({ objectConstructor: Secret, })

Defined in src/renderer/api/endpoints/secret.api.ts:48

### `Const` serviceAccountsApi

• serviceAccountsApi: KubeApi‹ServiceAccount‹›› = new KubeApi({ objectConstructor: ServiceAccount, })

Defined in src/renderer/api/endpoints/service-accounts.api.ts:27

### `Const` serviceApi

• serviceApi: KubeApi‹Service‹›› = new KubeApi({ objectConstructor: Service, })

Defined in src/renderer/api/endpoints/service.api.ts:101

### `Const` statefulSetApi

• statefulSetApi: StatefulSetApi‹› = new StatefulSetApi({ objectConstructor: StatefulSet, })

Defined in src/renderer/api/endpoints/stateful-set.api.ts:110

### `Const` storageClassApi

• storageClassApi: KubeApi‹StorageClass‹›› = new KubeApi({ objectConstructor: StorageClass, })

Defined in src/renderer/api/endpoints/storage-class.api.ts:37

## Functions

### forCluster

▸ forCluster‹T›(`cluster`: IKubeApiCluster, `kubeClass`: IKubeObjectConstructor‹T›): KubeApi‹T›

Defined in src/renderer/api/kube-api.ts:74

Type parameters:

▪ T: KubeObject

Parameters:

Name | Type
--- | ---
`cluster` | IKubeApiCluster
`kubeClass` | IKubeObjectConstructor‹T›

Returns: KubeApi‹T›

### isAllowedResource

▸ isAllowedResource(`resources`: KubeResource | KubeResource[]): boolean

Defined in src/common/rbac.ts:44

Parameters:

Name | Type
--- | ---
`resources` | KubeResource | KubeResource[]

Returns: boolean